﻿#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;
using ll = long long;

int solveA() {
    ll n;
   cin >> n;
    ll sum = 0, mx = 0;
    for (int i = 0; i < n; i++)
    {
        ll x;
        cin >> x;
        if (x % 2 == 0) {
            sum += x + x;
        }
        else {
            sum += x;
        }
        if (x % 3 == 0 && x > mx)
            mx = x;
    }
    cout << sum - mx;
    return 0;
}

int solveB() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector<ll> in, out;
    queue <ll> ang;
    for (ll i = 0; i < k; i++)
    {
        ll d, h, t;
        cin >> d >> h >> t;
        if (t == 1) {
            in.push_back(d * 24 + h);
        }
        else {
            out.push_back(d * 24 + h);
        }
    }
    sort(in.begin(), in.end());
    sort(out.begin(), out.end());
    ll i = 0, j = 0;
    ll cntin = 0, cntout = 0;
    queue<ll> waiting;
    while (i < in.size() && j < out.size()) {
        ll cur = min(in[i], out[j]);
        while (waiting.size() > 0 && ang.size() == 0 && waiting.front() < cur) {
            waiting.pop();
            cntout++;
        }
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
        if (in[i] < out[j]) {
            if (ang.size() < n)
                ang.push(in[i] + m);
            else
                cntin++;
            i++;
        }
        else {
            if (ang.size() && ang.front() <= out[j]) {
                ang.pop();
            }
            else {
                if (ang.size() > 0 || in[i] == out[j])
                    waiting.push(out[j]);
                else {
                    cntout++;
                }
            }
            j++;
        }
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
    }
    while (j < out.size()) {
        ll cur = out[j];
        while (waiting.size() > 0 && ang.size() == 0 && waiting.front() < cur) {
            waiting.pop();
            cntout++;
        }
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
        if (ang.size() && ang.front() <= out[j]) {
            ang.pop();
        }
        else {
            if (ang.size() > 0 )
                waiting.push(out[j]);
            else {
                cntout++;
            }
        } 
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
        j++;
    }
    while (i < in.size()) {
        ll cur = in[i];
        while (waiting.size() > 0 && ang.size() == 0 && waiting.front() < cur) {
            waiting.pop();
            cntout++;
        }
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
        if (ang.size() < n)
            ang.push(in[i] + m);
        else
            cntin++;
        while (waiting.size() > 0 && ang.size() && ang.front() <= cur) {
            ang.pop();
            waiting.pop();
        }
        i++;
    }
    while (waiting.size() > 0 && ang.size()) {
        ang.pop();
        waiting.pop();
    }
    cntout += waiting.size();
    cout << cntin << "\n" << cntout;
    return 0;
}

int solveC() {
    ll a, b;
    cin >> a >> b;
    vector<bool> mas(b + 1, false);
    vector<ll> p;
    for (ll i = 2; i < b + 1; i += 2)
    {
        if (mas[i])
            continue;
        if (i > 2) {
            p.push_back(i);
        }
        for (ll j = i * i; j < b + 1; j += 2 * i)
        {
            mas[j] = true;
        }
        if (i == 2)
            i--;
    }
    vector<ll> vec(b + 1, 0);
    vec[0] = 1000000000;
    ll ans = 0, lst = a + (a % 2);
    for (ll i = 0; i < p.size(); i++)
    {
        ll  l = lower_bound(p.begin(), p.end(), a - p[i]) - p.begin();
        ll  r = upper_bound(p.begin(), p.end(), b - p[i]) - p.begin();
        l = max(l, i + 1);
        for (ll j = lst; j < p[i] + p[min(i + 1, ll(p.size() - 1))] && j < b + 1 && vec[ans] > 5; j += 2)
        {
            if (vec[j] % 5 == 0 && vec[j] > 0 && vec[j] < vec[ans])
                ans = j;
        }
        if (vec[ans] == 5)
            break;
        lst = max(lst, p[i] + p[min(i + 1, ll(p.size() - 1))]);
        while (l < r ) {
            vec[p[i] + p[l]]++;
            l++;
        }
    }
    for (ll i = lst; i < b + 1 && vec[ans] > 5; i += 2)
    {
        if (vec[i] % 5 == 0 && vec[i] > 0 && vec[i] < vec[ans])
            ans = i;
    }
    if (ans == 0)
        cout << "Impossible";
    else
        cout << ans << " " << vec[ans];
    return 0;
}

int solveD() {
    ll n;
    cin >> n;
    ll cnt = 0;
    for (ll i = 0; i < n; i++)
    {
        ll x;
        cin >> x;
        while (x) {
            if ((x % 13) % 6 == 0)
                cnt++;
            x /= 13;
        }
    }
    cout << cnt;
    return 0;
}

int solveE() {
    ll n;
    cin >> n;
    ll m;
    cin >> m;
    vector<ll> a(n);
    ll cnt = 0;
    for (ll i = 0; i < n; i++)
    {
        cin >> a[i];
        cnt += a[i];
    }
    map<ll, ll> mp;
    ll mx = 0;
    for (ll i = 0; i < n; i++)
    {
        if (a[i] > m && a[i] * n < cnt) {
            mp[a[i]]++;
            if (mp[a[i]] == mp[mx] && a[i] > mx)
                mx = a[i];
            if (mp[a[i]] > mp[mx])
                mx = a[i];
        }
    }
    cout << mx;
    return 0;
}

int solveF() {
    ll n;
    cin >> n;
    vector<bool> po(n + 1), cons(n + 1, true);
    vector<pair<ll, ll>> ne, q;
    vector<pair<pair<ll, ll>, ll>> an;
    map<ll, ll> mp;
    ll mx = 0;
    for (ll i = 0; i < n; i++)
    {
        ll t;
        cin >> t;
        if (t == 0) {
            ll p, s;
            cin >> p >> s;
            po[p] = bool(s == 1);
        }
        if (t == 1) {
            ll in, out;
            cin >> in >> out;
            ne.push_back({ in, out });
            cons[out] = false;
        }
        if (t == 2) {
            ll s1, s2, o;
            cin >> s1 >> s2 >> o;
            an.push_back({ {s1, s2}, o });
            cons[o] = false;
        }
        if (t == 3) {
            ll p, ti;
            cin >> p >> ti;
            q.push_back({ p, ti });
            mx = max(ti, mx);
        }
    }
    vector<vector<bool>> dp(mx + 1, vector<bool>(n + 1, false));
    dp[0] = po;
    for (ll i = 1; i < mx + 1; i++)
    {
        for (ll j = 0; j < ne.size(); j++)
        {
            dp[i][ne[j].second] = (dp[i][ne[j].second] || !dp[i - 1][ne[j].first]);
        }
        for (ll j = 0; j < an.size(); j++)
        {
            bool f = bool(dp[i - 1][an[j].first.first] && dp[i - 1][an[j].first.second]);
            dp[i][an[j].second] = (dp[i][an[j].second] || f);
        }
        for (ll j = 0; j < n + 1; j++)
        {
            if (cons[j])
                dp[i][j] = dp[i - 1][j];
        }
    }
    for (ll i = 0; i < q.size(); i++)
    {
        for (ll j = 1; j <= q[i].second; j++)
        {
            cout << dp[j][q[i].first] << "\n";
        }
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    bool multy = false;
    if (multy)
        cin >> t;
    while (t--) {
        solveB();
    }
    return 0;
}