﻿#include <iostream>
#include <vector>
#include <numeric>
#include <string.h>
#include <fstream>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

struct Event {
	ll time;
	int type;

	bool operator <(Event const other) const {
		if (time != other.time) {
			return time > other.time;
		}

		return type > other.type;
	}
};

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	priority_queue<Event> q;
	for (int i = 0; i < k; ++i) {
		ll day, hour;
		int type;
		cin >> day >> hour >> type;

		q.push(Event{ 24 * day + hour, type });
	}

	int reject = 0;
	int delayed = 0;
	int ready = 0;
	int used = 0;

	while (!q.empty()) {
		Event event = q.top();
		q.pop();

		if (event.type == -2) {
			if (delayed > 0) {
				delayed--;
				used--;
			}
			else {
				ready++;
			}
		}

		if (event.type == -1) {
			if (ready > 0) {
				ready--;
				used--;
			}
			else {
				delayed++;
			}
		}

		if (event.type == 1) {
			if (used < n) {
				q.push(Event{ event.time + 24 * m, -2 });
				used++;
			}
			else {
				reject++;
			}
		}
	}

	cout << reject << "\n" << delayed;
}