﻿#include <iostream>
#include <vector>
#include <numeric>
#include <string.h>
#include <fstream>
#include <queue>
#include <set>

using namespace std;
using ll = long long;
using pii = pair<int, int>;

int N = 2'000'000;

int main() {
	vector<int> is_prime(N, 1);
	is_prime[1] = 0;

	for (int i = 2; i < N; ++i) {
		if (is_prime[i]) {
			for (int j = 2 * i; j < N; j += i) {
				is_prime[j] = 0;
			}
		}
	}

	vector<int> primes;
	for (int i = 2; i < N; ++i) {
		if (is_prime[i]) {
			primes.push_back(i);
		}
	}

	int a, b;
	cin >> a >> b;

	a += (a % 2);
	b -= (b % 2);

	int num = -1;
	int mnx = 1e9;

	for (int i = a; i <= b; i += 2) {
		int g = 0;

		for (int x : primes) {
			if (i - x < x || g >= mnx) {
				break;
			}

			g += is_prime[i - x];
		}

		if (g % 5 == 0 && g < mnx) {
			num = i;
			mnx = g;
		}
	}

	if (num == -1) {
		cout << "Impossible";
		return 0;
	}

	cout << num << " " << mnx << "\n";
}