﻿#include <iostream>
#include <vector>
#include <numeric>
#include <string.h>
#include <fstream>
#include <queue>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;

int N = 200;

struct AndComp {
	int x, y, z;
	int a, b;
};

struct NotComp {
	int x, y;
	int a;
};

void update(vector<int>& state, vector<AndComp>& AndComps, vector<NotComp>& NotComps) {
	for (auto& comp : AndComps) {
		comp.a = state[comp.x];
		comp.b = state[comp.y];
	}

	for (auto& comp : NotComps) {
		comp.a = state[comp.x];
	}

	for (auto& comp : AndComps) {
		state[comp.z] = 0;
	}

	for (auto& comp : NotComps) {
		state[comp.y] = 0;
	}
}

int main() {
	int n;
	cin >> n;

	vector<int> state(N);
	vector<AndComp> AndComps;
	vector<NotComp> NotComps;

	int k = 0;
	int t = 0;

	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;

		if (type == 0) {
			int m, x;
			cin >> m >> x;

			state[m] = x;
		}

		if (type == 1) {
			int x, y;
			cin >> x >> y;

			NotComps.push_back(NotComp{ x, y, 0 });
		}

		if (type == 2) {
			int x, y, z;
			cin >> x >> y >> z;

			AndComps.push_back(AndComp{ x, y, z, 0, 0 });
		}

		if (type == 3) {
			cin >> k >> t;
		}
	}

	for (int tick = 0; tick < t; ++tick) {
		update(state, AndComps, NotComps);

		for (auto comp : AndComps) {
			state[comp.z] |= (comp.a & comp.b);
		}

		for (auto comp : NotComps) {
			state[comp.y] |= (comp.a ^ 1);
		}

		cout << state[k] << "\n";
	}
}